package {

    import flash.display.Sprite;
    import flash.text.TextField;
    import flash.display.DisplayObject;
    import flash.display.SimpleButton;
    import flash.events.MouseEvent;
    import flash.events.Event;
    import flash.net.URLRequest;
    import flash.net.navigateToURL;
    import flash.utils.getDefinitionByName;

    import PushButton; // Класс кнопки, лежащий в PushButton.as

    // Параметры SWF-файла
    [SWF(width="550", height="380")]

    // Интегрирование прелоадера, лежащего в Preloader.as
    [Frame(factoryClass="Preloader")]

    // Основной класс программы
    public class Main extends Sprite 
    {
      // Картинки кадров (будут храниться в массиве как DisplayObject)
      public var kadr:Array=new Array(); 

      // Параметры картинок-кадров
      public var kadr_num:int=3; // Количество картинок-кадров
      public var kadr_current_num:int=1;
      public var kadr_move_step:int=10;
      public var kadr_size_x:int=464;
      public var kadr_size_y:int=380;

      // Текущее состояние программы
      public var state:String="wait_action";


      // Конструктор основного класса
      public function Main():void 
      {
       if (stage) init(); 
       else addEventListener(Event.ADDED_TO_STAGE, init);
      }


      // Точка входа, после того как загрузился весь ролик
	  public function init(e:Event = null):void
	  {
	    var i:int;

	    // Отключение обслуживания прелоадера
        removeEventListener(Event.ADDED_TO_STAGE, init);


		// Библиотека картинок
        [Embed(source="logo.png")]   var symbol_logo:Class;
        [Embed(source="kadr_1.png")] var symbol_kadr_1:Class;
        [Embed(source="kadr_2.png")] var symbol_kadr_2:Class;
        [Embed(source="kadr_3.png")] var symbol_kadr_3:Class;

		// Загрузка картинки логотипа из библиотеки
        var logo:DisplayObject=new symbol_logo();

		// Загрузка картинок с кадрами из библиотеки
        kadr[1]=new symbol_kadr_1();
        kadr[2]=new symbol_kadr_2();
        kadr[3]=new symbol_kadr_3();

        // Для загрузки можно попробовать другой код:
   		/*
		for(i=1; i<=kadr_num; i++) 
		 {
          var img:Class=getDefinitionByName("symbol_kadr_" + i.toString()) as Class;
          kadr[i]=new img(); 
         }
        */


        // Логотип добавляется на холст (т.е. на Sprite)
        // и задаются координаты
        addChild(logo);
        logo.x=kadr_size_x+27;
        logo.y=25;
         
        // Картинки кадров добавляются на холст с координатами 0:0
        // и делаются невидимыми
        for(i=1; i<=kadr_num; i++)
         {        
          addChild(kadr[i]);
          kadr[i].visible=false;
         }

        // Первая картинка-кадр делается видимой
        kadr[kadr_current_num].visible=true;


		// Надпись на логотипе добавляется на холст
		var display_txt:TextField = new TextField();
		display_txt.text = "ImageView";
		display_txt.selectable=false;
		display_txt.x=kadr_size_x+15;
		display_txt.y=5;
		addChild(display_txt);


        // Добавляем кнопку "Назад"
        var back_button:PushButton=new PushButton(kadr_size_x+30,150,24,24,"ᐃ");
        back_button.addEventListener(MouseEvent.CLICK, back_click);
        addChild(back_button);

        // Добавляем кнопку "Вперед"
        var forward_button:PushButton=new PushButton(kadr_size_x+30,180,24,24,"ᐁ");
        forward_button.addEventListener(MouseEvent.CLICK, forward_click);
        addChild(forward_button);

        // Добавляем кнопку "Site"
        var go_button:PushButton=new PushButton(kadr_size_x+23,kadr_size_y-18,42,16,"Site");
        go_button.addEventListener(MouseEvent.CLICK, go_click);
        addChild(go_button);

        // Запускаем основной цикл (main loop)
        addEventListener(Event.ENTER_FRAME, main_loop);
	  }


	 // Основной цикл
     public function main_loop(event:Event):void
     {
      if(state=="wait_action") return;

      // Если происходит движение вперед (кадры движгаются вверх)
      if(state=="roll_forward")
       {
        // Y-координата кадров уменьшается на нужный шаг
        kadr[kadr_current_num].y-=kadr_move_step;
        kadr[kadr_current_num+1].y-=kadr_move_step;

        // Когда кадр полностью перемотан
        if(kadr[kadr_current_num].y<=(-kadr_size_y))
         {
          // Уехавший кадр скрывается
          kadr[kadr_current_num].y=0;
          kadr[kadr_current_num].visible=false;

          // Приехавший кадр выравнивается
          kadr[kadr_current_num+1].y=0;

          kadr_current_num=kadr_current_num+1;

          state="wait_action";
         }
       }

      // Если происходит движение назад (кадры двигаются вниз)
      if(state=="roll_back")
       {
        // Y-координата кадров увеличивается на нужный шаг
        kadr[kadr_current_num].y+=kadr_move_step;
        kadr[kadr_current_num-1].y+=kadr_move_step;

        // Когда кадр полностью перемотан
        if(kadr[kadr_current_num].y>=kadr_size_y)
         {
          // Уехавший кадр скрывается
          kadr[kadr_current_num].y=0;
          kadr[kadr_current_num].visible=false;

          // Приехавший кадр выравнивается
          kadr[kadr_current_num-1].y=0;

          kadr_current_num=kadr_current_num-1;

          state="wait_action";
         }
       }

     }


     // Обработка кнопки назад (т.е. вверх)
     private function back_click(event:MouseEvent):void     
     {
      if(state=="wait_action")
       {
        // Перемещаться нельзя, если начальный кадр
        if(kadr_current_num==1) return;

        state="roll_back";

        kadr[kadr_current_num].visible=true;

        kadr[kadr_current_num-1].x=0;
        kadr[kadr_current_num-1].y=(-kadr_size_y);
        kadr[kadr_current_num-1].visible=true;
       }
     }


     // Обработка кнопки вперед (т.е. вниз)
     private function forward_click(event:MouseEvent):void     
     {
      if(state=="wait_action")
       {
        // Перемещаться нельзя, если конечный кадр
        if(kadr_current_num==(kadr_num)) return;

        state="roll_forward";

        kadr[kadr_current_num].visible=true;

        kadr[kadr_current_num+1].x=0;
        kadr[kadr_current_num+1].y=kadr_size_y;
        kadr[kadr_current_num+1].visible=true;
       }
     }


     // Обработка кнопки перехода по указанному URL
     private function go_click(event:MouseEvent):void     
     {
      var url:String="http://webhamster.ru";
      var url_request:URLRequest=new URLRequest(url);
      navigateToURL(url_request, "_self");
     } 

    }
}
